#!/bin/bash

AST_TEST_DIR='ast_tests/'
SUCCESS_COUNT=0
FAIL_COUNT=0

for x in `ls $AST_TEST_DIR | grep tokens`; do
  # run menhir
  cat $AST_TEST_DIR$x | tr '\n' ' ' | echo -e "$(cat -)" | menhir --interpret --interpret-show-cst parser.mly > output
  # compare output to expected output
  TEST_NAME=`echo $x | cut -d'.' -f1`
  # DIFF=$(diff output $AST_TEST_DIR$TEST_NAME.out)
  if [[ `cat output | grep REJECT` != ""  && $x =~ "test" ]]; then
    echo $TEST_NAME FAIL
    FAIL_COUNT=$(($FAIL_COUNT + 1))
  elif [[ `cat output | grep REJECT` == "" && $x =~ "fail" ]]; then
    echo $TEST_NAME FAIL
    FAIL_COUNT=$(($FAIL_COUNT + 1))
  else
    SUCCESS_COUNT=$(($SUCCESS_COUNT + 1))
  fi
done
rm output
echo $SUCCESS_COUNT TESTS SUCCEEDED
echo $FAIL_COUNT TESTS FAILED
